import { Db } from '../data/db';
export interface IDdfFileDescriptor {
    valid: boolean;
    filename?: string;
    name?: string;
    fullPath?: string;
    rootFolder?: string;
    type?: symbol;
    parts?: string[];
    constraints?: any;
    headers?: string[];
    primaryKey?: string | string[];
    directoryIndex?: number;
}
export declare const DATA_PACKAGE_FILE = "datapackage.json";
export declare const stripDdfPrefix: (filename: any) => any;
export declare class DataPackage {
    rootFolder: string;
    errors: any[];
    warnings: any[];
    fileDescriptors: IDdfFileDescriptor[];
    translationFolders: any[];
    db: Db;
    settings: any;
    consistencyDescriptor: any;
    private dataPackageContent;
    private isNewDataPackage;
    constructor(rootFolder: string, settings: any);
    getTranslationFileDescriptors(onTranslationsFileDescriptorsReady: Function): void;
    fillConstraints(ddfFileDescriptor: IDdfFileDescriptor): IDdfFileDescriptor;
    getDdfFileDescriptors(folder: string, settings: any, onDdfFileDescriptorsReady: Function): void;
    fillHeaders(onHeadersReady: any): void;
    fillPrimaryKeys(conceptTypeHash: any, conceptDomainHash: any): void;
    getDataPackageObject(): any;
    buildDataPackageResources(onDataPackageReady: any): void;
    read(onDataPackageReady: any): void;
    setSchema(ddfSchema: any): void;
    getTranslations(): any;
    take(onDataPackageReady: Function, ignoreExistingDataPackage: boolean): void;
    isValid(): boolean;
}
