"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const lodash_1 = require("lodash");
exports.isPathExpected = (folderPath, externalExcludedFolders = []) => {
    if (!folderPath) {
        return false;
    }
    const folders = folderPath.split(path.sep);
    if (lodash_1.includes(folders, '.git') ||
        lodash_1.includes(folders, 'etl') ||
        lodash_1.includes(folders, 'lang') ||
        lodash_1.includes(folders, 'assets')) {
        return false;
    }
    if (!lodash_1.isEmpty(folders.filter(folder => lodash_1.includes(externalExcludedFolders, folder)))) {
        return false;
    }
    return true;
};
exports.getRelativePath = (fullFolderPath, rootFolder) => path.relative(rootFolder, fullFolderPath);
exports.getExcludedDirs = (settings) => {
    if (settings && settings.excludeDirs) {
        const excludeDirs = lodash_1.isString(settings.excludeDirs) ? lodash_1.split(settings.excludeDirs, ',') : settings.excludeDirs;
        return excludeDirs.map(dir => lodash_1.trim(dir.replace(/["']/g, '')));
    }
    return [];
};
