"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
exports.getArrayInAnyCase = (value) => !lodash_1.isArray(value) ? [value] : value;
exports.CONCEPT = Symbol.for('concepts');
exports.ENTITY = Symbol.for('entities');
exports.DATA_POINT = Symbol.for('datapoints');
exports.SYNONYM = Symbol.for('synonyms');
exports.LINE_NUM_INCLUDING_HEADER = 2;
exports.DDF_SEPARATOR = '--';
exports.DDF_DATAPOINT_SEPARATOR = 'by';
exports.CONCEPT_ID = 'concept';
exports.CONCEPT_TYPE = 'concept_type';
exports.SYNONYM_ID = 'synonym';
exports.DOMAIN_ID = 'domain';
exports.PREDEFINED_CONCEPTS = [exports.CONCEPT_ID, exports.CONCEPT_TYPE];
exports.TRANSLATIONS_FOLDER = 'lang';
exports.getTypeByPrimaryKey = (primaryKeyParam) => {
    const primaryKey = exports.getArrayInAnyCase(primaryKeyParam);
    if (primaryKey.length === 1 && lodash_1.head(primaryKey) === exports.CONCEPT_ID) {
        return exports.CONCEPT;
    }
    if (primaryKey.length !== 1 && lodash_1.includes(primaryKey, exports.CONCEPT_ID) && !lodash_1.includes(primaryKey, exports.SYNONYM_ID)) {
        return null;
    }
    if (primaryKey.length === 1 && lodash_1.head(primaryKey) !== exports.CONCEPT_ID) {
        return exports.ENTITY;
    }
    if (primaryKey.length < 2 && lodash_1.includes(primaryKey, exports.SYNONYM_ID)) {
        return null;
    }
    if (primaryKey.length >= 2 && lodash_1.includes(primaryKey, exports.SYNONYM_ID)) {
        return exports.SYNONYM;
    }
    if (primaryKey.length > 1) {
        return exports.DATA_POINT;
    }
    return null;
};
exports.getDecoratedDataPackageObject = (dataPackageObject) => ({
    getDataPackageObject: () => dataPackageObject,
    getAllResources: () => dataPackageObject.resources
});
