import { Db } from '../data/db';
import { DataPackage } from '../data/data-package';
import { FileDescriptor } from '../data/file-descriptor';
export declare class DdfDataSet {
    rootPath: string;
    db: Db;
    expectedClass: any;
    definitions: any;
    errors: any[];
    settings: any;
    ignoreExistingDataPackage: boolean;
    dataPackageDescriptor: DataPackage;
    isEmpty: boolean;
    isDDF: boolean;
    fileDescriptors: FileDescriptor[];
    wrongFileDescriptors: FileDescriptor[];
    constructor(rootPath: string, settings: any, ignoreExistingDataPackage?: boolean);
    load(onDataSetLoaded: any): void;
    getConcept(): any;
    getEntity(): any;
    getSynonym(): any;
    getDataPoint(): any;
    getAllMeasures(): any;
    getConceptsByType(...types: string[]): any;
    getDataPackageDescriptor(): DataPackage;
    getTranslations(onTranslationsReady: any): void;
    check(onDirectoryDescriptorReady: Function): void;
    createDataPackage(onDataPackageCreated: Function): void;
    getFileDescriptor(dir: any, ddfResource: any): FileDescriptor;
    getDataPackageResources(): any;
    getDataPackageSchema(): any;
    fillDdfSchema(onDdfSchemaReady: Function, isSilent?: boolean): void;
    writeDataPackage(settings: any, existingDataPackage: any, onDataPackageFileReady: Function): void;
}
