"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const COLLECTION_NAME = 'synonyms';
class Synonym {
    constructor(db) {
        this.db = db;
        this.collection = this.db.getCollection(COLLECTION_NAME);
        this.fileDescriptors = [];
    }
    getAllData() {
        return this.collection;
    }
    getDataByFiles() {
        return lodash_1.groupBy(this.getAllData(), record => record['$$source']);
    }
    addFileDescriptor(fileDescriptor) {
        this.fileDescriptors.push(fileDescriptor);
    }
}
exports.Synonym = Synonym;
