"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    rule: (ddfDataSet) => {
        const concept = ddfDataSet.getConcept();
        const paths = concept.fileDescriptors.map(fileDescriptor => fileDescriptor.fullPath);
        let result = null;
        const conceptsIds = concept
            .getAllData()
            .map(conceptRecord => conceptRecord.concept);
        const nonUniqueConceptIds = lodash_1.transform(lodash_1.countBy(conceptsIds), (_result, count, value) => {
            if (count > 1) {
                _result.push(value);
            }
        }, []);
        if (!lodash_1.isEmpty(nonUniqueConceptIds)) {
            result = new issue_1.Issue(registry_1.CONCEPT_ID_IS_NOT_UNIQUE)
                .setPath(paths)
                .setData(nonUniqueConceptIds);
        }
        return result;
    }
};
