"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
const ddf_things_1 = require("../../utils/ddf-things");
exports.rule = {
    rule: (ddfDataSet) => {
        const conceptData = ddfDataSet.getConcept().getAllData();
        const issues = [];
        for (let record of conceptData) {
            if (!lodash_1.includes(ddf_things_1.CONCEPT_TYPES, record.concept_type)) {
                const issue = new issue_1.Issue(registry_1.INCORRECT_CONCEPT_TYPE)
                    .setPath(record.$$source)
                    .setData({ lineNumber: record.$$lineNumber, type: record.concept_type });
                issues.push(issue);
            }
        }
        return issues;
    }
};
