"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const issue_1 = require("../issue");
const registry_1 = require("../../ddf-rules/registry");
const constants_1 = require("../../ddf-definitions/constants");
const getIssues = (ddfDataSet) => {
    const result = ddfDataSet.getDataPackageResources()
        .filter(resource => constants_1.getTypeByPrimaryKey(resource.schema.primaryKey) === constants_1.DATA_POINT)
        .filter(resource => lodash_1.isEmpty(lodash_1.difference(lodash_1.map(resource.schema.fields, 'name'), resource.schema.primaryKey)))
        .map(resource => new issue_1.Issue(registry_1.DATA_POINT_WITHOUT_INDICATOR).setPath(resource.path).setData(resource));
    return lodash_1.compact(lodash_1.flattenDeep(result));
};
exports.rule = {
    rule: (ddfDataSet) => getIssues(ddfDataSet)
};
