"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    rule: (ddfDataSet) => {
        const names = ddfDataSet.getDataPackageResources().map(resource => resource.name);
        const duplicates = lodash_1.filter(names, (value, index, iteratee) => lodash_1.includes(iteratee, value, index + 1));
        let issue = null;
        if (!lodash_1.isEmpty(duplicates)) {
            issue = new issue_1.Issue(registry_1.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME)
                .setPath(ddfDataSet.rootPath)
                .setData({ duplicates });
        }
        return lodash_1.compact([issue]);
    }
};
