"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const lodash_1 = require("lodash");
const issue_1 = require("../issue");
const registry_1 = require("../registry");
const data_package_1 = require("../../data/data-package");
exports.rule = {
    rule: (ddfDataSet) => {
        const dataPackagePath = path.resolve(ddfDataSet.dataPackageDescriptor.rootFolder, data_package_1.DATA_PACKAGE_FILE);
        const generatedResources = ddfDataSet.dataPackageDescriptor.newDataPackageContent.resources.map(r => r.name);
        const currentResources = ddfDataSet.dataPackageDescriptor.getDataPackageObject().resources.map(r => r.name);
        const diff = lodash_1.difference(generatedResources, currentResources);
        const newResources = diff.filter(r => lodash_1.includes(generatedResources, r));
        console.log(JSON.stringify(generatedResources, null, 2));
        console.log();
        console.log(JSON.stringify(currentResources, null, 2));
        if (!lodash_1.isEmpty(newResources)) {
            return [new issue_1.Issue(registry_1.OUTDATED_DATAPACKAGE)
                    .setPath(dataPackagePath)
                    .setData({ newResources })];
        }
        return [];
    }
};
