"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const issue_1 = require("../issue");
const registry_1 = require("../registry");
exports.rule = {
    rule: (ddfDataSet) => {
        const schemaBlock = ddfDataSet.getDataPackageSchema();
        if (lodash_1.isEmpty(schemaBlock)) {
            return [];
        }
        const schema = lodash_1.compact(lodash_1.concat(ddfDataSet.getDataPackageSchema().concepts, ddfDataSet.getDataPackageSchema().entities, ddfDataSet.getDataPackageSchema().datapoints, ddfDataSet.getDataPackageSchema().synonyms));
        const issues = schema
            .filter(schemaRecord => lodash_1.includes(schemaRecord.primaryKey, schemaRecord.value))
            .map(schemaRecord => new issue_1.Issue(registry_1.SAME_KEY_VALUE_CONCEPT)
            .setPath(ddfDataSet.dataPackageDescriptor.rootFolder)
            .setData({ schemaRecord, reason: `Value ${schemaRecord.value} already exists in primaryKey` }));
        return issues;
    }
};
