"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const shared_1 = require("./shared");
const issue_1 = require("../issue");
exports.rule = {
    isDataPoint: true,
    resetStorage: () => {
        shared_1.resetCache();
    },
    recordRule: dataPointDescriptor => {
        const constraints = shared_1.cacheFor.constraintsByFileDescriptor(dataPointDescriptor);
        const constraintViolation = (constraint) => {
            return !lodash_1.includes(constraint.constraints, dataPointDescriptor.record[constraint.fieldName]);
        };
        return lodash_1.compact(lodash_1.flattenDeep(constraints.filter(constraintViolation).map((constraint) => new issue_1.Issue(registry_1.DATA_POINT_CONSTRAINT_VIOLATION).setPath(constraint.fullPath).setData({
            constraints: constraint.constraints,
            fieldName: constraint.fieldName,
            fieldValue: dataPointDescriptor.record[constraint.fieldName],
            line: dataPointDescriptor.line
        }))));
    }
};
