"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const constants_1 = require("../../ddf-definitions/constants");
const issue_1 = require("../issue");
const shared_1 = require("./shared");
exports.rule = {
    isDataPoint: true,
    resetStorage: () => {
        shared_1.resetCache();
    },
    recordRule: dataPointDescriptor => {
        const entities = shared_1.cacheFor.getEntitiesByRecord(dataPointDescriptor);
        const entityValueHash = shared_1.cacheFor.getEntityValueHash(dataPointDescriptor);
        const issues = [];
        for (let entity of entities) {
            const entityKey = `${entity}@${dataPointDescriptor.record[entity]}`;
            if (!lodash_1.includes(entityValueHash[entityKey], entity)) {
                const issue = new issue_1.Issue(registry_1.DATA_POINT_UNEXPECTED_ENTITY_VALUE)
                    .setPath(dataPointDescriptor.fileDescriptor.fullPath)
                    .setData({
                    concept: entity,
                    line: dataPointDescriptor.line + constants_1.LINE_NUM_INCLUDING_HEADER,
                    value: dataPointDescriptor.record[entity]
                });
                issues.push(issue);
            }
        }
        return issues;
    }
};
