"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const registry_1 = require("../registry");
const constants_1 = require("../../ddf-definitions/constants");
const shared_1 = require("./shared");
const issue_1 = require("../issue");
const ddf_things_1 = require("../../utils/ddf-things");
const ddfTimeUtils = require('ddf-time-utils');
exports.rule = {
    isDataPoint: true,
    resetStorage: () => {
        shared_1.resetCache();
    },
    recordRule: dataPointDescriptor => shared_1.cacheFor.keysByType(dataPointDescriptor, ddf_things_1.CONCEPT_TYPE_TIME)
        .filter(timeKey => !ddfTimeUtils.detectTimeType(dataPointDescriptor.record[timeKey]))
        .map(timeKey => new issue_1.Issue(registry_1.DATA_POINT_UNEXPECTED_TIME_VALUE)
        .setPath(dataPointDescriptor.fileDescriptor.fullPath)
        .setData({
        concept: timeKey,
        line: dataPointDescriptor.line + constants_1.LINE_NUM_INCLUDING_HEADER,
        value: dataPointDescriptor.record[timeKey]
    }))
};
