"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    rule: (ddfDataSet) => ddfDataSet.getEntity().getAllData()
        .filter(record => {
        const resource = ddfDataSet.getDataPackageResources().find(resource => lodash_1.endsWith(record.$$source, resource.path));
        const primaryKey = resource.schema.primaryKey;
        return !record[primaryKey];
    })
        .map(conceptRecordWithEmptyId => new issue_1.Issue(registry_1.EMPTY_ENTITY_ID)
        .setPath(conceptRecordWithEmptyId.$$source)
        .setData({ line: conceptRecordWithEmptyId.$$lineNumber }))
};
