"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const constants_1 = require("../../ddf-definitions/constants");
const issue_1 = require("../issue");
const ddf_things_1 = require("../../utils/ddf-things");
exports.rule = {
    rule: (ddfDataSet) => {
        const result = [];
        const entities = ddfDataSet.getEntity().getDataByFiles();
        const entityFiles = lodash_1.keys(entities);
        entityFiles.forEach(entityFile => {
            if (!lodash_1.isEmpty(entities[entityFile])) {
                const expectedKeys = lodash_1.keys(lodash_1.head(entities[entityFile]))
                    .filter(entityRecordKey => ddf_things_1.looksLikeIsField(entityRecordKey));
                entities[entityFile].forEach(entityRecord => {
                    expectedKeys.forEach(key => {
                        if (!ddf_things_1.isDdfBoolean(entityRecord[key])) {
                            const data = {
                                header: key,
                                line: entityRecord.$$lineNumber + constants_1.LINE_NUM_INCLUDING_HEADER,
                                value: entityRecord[key]
                            };
                            const issue = new issue_1.Issue(registry_1.WRONG_ENTITY_IS_VALUE)
                                .setPath(entityFile)
                                .setData(data);
                            result.push(issue);
                        }
                    });
                });
            }
        });
        return result;
    }
};
