"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    rule: (ddfDataSet) => {
        const issues = [];
        const synonymsData = ddfDataSet.getSynonym().getAllData();
        for (const record of synonymsData) {
            const resource = ddfDataSet.getDataPackageResources().find(resource => lodash_1.endsWith(record.$$source, resource.path));
            const primaryKey = resource.schema.primaryKey;
            const undefinedKeyParts = [];
            for (const partOfPrimaryKey of primaryKey) {
                if (lodash_1.isEmpty(record[partOfPrimaryKey])) {
                    undefinedKeyParts.push(partOfPrimaryKey);
                }
            }
            if (!lodash_1.isEmpty(undefinedKeyParts)) {
                issues.push(new issue_1.Issue(registry_1.INCONSISTENT_SYNONYM_KEY)
                    .setPath(record.$$source)
                    .setData({ line: record.$$lineNumber, undefinedKeyParts }));
            }
        }
        return issues;
    }
};
