"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const registry = require("./registry");
const concept_id_is_not_unique_1 = require("./concept-rules/concept-id-is-not-unique");
const empty_concept_id_1 = require("./concept-rules/empty-concept-id");
const empty_entity_id_1 = require("./entity-rules/empty-entity-id");
const incorrect_concept_type_1 = require("./concept-rules/incorrect-concept-type");
const non_concept_header_1 = require("./concept-rules/non-concept-header");
const concept_mandatory_field_not_found_1 = require("./concept-rules/concept-mandatory-field-not-found");
const concepts_not_found_1 = require("./concept-rules/concepts-not-found");
const invalid_drill_up_1 = require("./concept-rules/invalid-drill-up");
const incorrect_file_1 = require("./data-package-rules/incorrect-file");
const incorrect_fields_1 = require("./data-package-rules/incorrect-fields");
const non_concept_field_1 = require("./data-package-rules/non-concept-field");
const incorrect_primary_key_1 = require("./data-package-rules/incorrect-primary-key");
const non_unique_resource_name_1 = require("./data-package-rules/non-unique-resource-name");
const non_unique_resource_file_1 = require("./data-package-rules/non-unique-resource-file");
const datapoint_without_indicator_1 = require("./data-package-rules/datapoint-without-indicator");
const same_key_value_concept_1 = require("./data-package-rules/same-key-value-concept");
const nonexistent_resource_1 = require("./data-package-rules/nonexistent-resource");
const nonexistent_concept_1 = require("./data-package-rules/nonexistent-concept");
const inconsistent_datapackage_1 = require("./data-package-rules/inconsistent-datapackage");
const duplicated_synonym_key_1 = require("./general-rules/duplicated-synonym-key");
const inconsistent_synonym_key_1 = require("./general-rules/inconsistent-synonym-key");
const unexpected_entity_value_1 = require("./data-point-rules/unexpected-entity-value");
const unexpected_time_value_1 = require("./data-point-rules/unexpected-time-value");
const constraint_violation_1 = require("./data-point-rules/constraint-violation");
const duplicated_data_point_key_1 = require("./data-point-rules/duplicated-data-point-key");
const non_unique_entity_value_1 = require("./entity-rules/non-unique-entity-value");
const wrong_entity_is_header_1 = require("./entity-rules/wrong-entity-is-header");
const wrong_entity_is_value_1 = require("./entity-rules/wrong-entity-is-value");
const unexisting_constraint_value_1 = require("./entity-rules/unexisting-constraint-value");
const incorrect_boolean_entity_1 = require("./entity-rules/incorrect-boolean-entity");
const concept_looks_like_boolean_1 = require("./entity-rules/concept-looks-like-boolean");
const unexpected_data_1 = require("./general-rules/unexpected-data");
const wrong_data_point_header_1 = require("./general-rules/wrong-data-point-header");
const incorrect_identifier_1 = require("./general-rules/incorrect-identifier");
const incorrect_json_field_1 = require("./general-rules/incorrect-json-field");
const non_ddf_dataset_1 = require("./general-rules/non-ddf-dataset");
const unexpected_translation_header_1 = require("./translation-rules/unexpected-translation-header");
const unexpected_translations_data_1 = require("./translation-rules/unexpected-translations-data");
const unexpected_data_point_translations_data_1 = require("./translation-rules/unexpected-data-point-translations-data");
const duplicated_data_point_translation_key_1 = require("./translation-rules/duplicated-data-point-translation-key");
const duplicated_translation_key_1 = require("./translation-rules/duplicated-translation-key");
const entity_value_as_entity_name_1 = require("./entity-rules/entity-value-as-entity-name");
exports.allRules = {
    [registry.CONCEPT_ID_IS_NOT_UNIQUE]: concept_id_is_not_unique_1.rule,
    [registry.EMPTY_CONCEPT_ID]: empty_concept_id_1.rule,
    [registry.EMPTY_ENTITY_ID]: empty_entity_id_1.rule,
    [registry.INCORRECT_CONCEPT_TYPE]: incorrect_concept_type_1.rule,
    [registry.NON_CONCEPT_HEADER]: non_concept_header_1.rule,
    [registry.CONCEPT_MANDATORY_FIELD_NOT_FOUND]: concept_mandatory_field_not_found_1.rule,
    [registry.CONCEPTS_NOT_FOUND]: concepts_not_found_1.rule,
    [registry.INVALID_DRILL_UP]: invalid_drill_up_1.rule,
    [registry.INCORRECT_FILE]: incorrect_file_1.rule,
    [registry.DATAPACKAGE_INCORRECT_FIELDS]: incorrect_fields_1.rule,
    [registry.DATAPACKAGE_NON_CONCEPT_FIELD]: non_concept_field_1.rule,
    [registry.DATAPACKAGE_INCORRECT_PRIMARY_KEY]: incorrect_primary_key_1.rule,
    [registry.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME]: non_unique_resource_name_1.rule,
    [registry.DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE]: non_unique_resource_file_1.rule,
    [registry.INCONSISTENT_DATAPACKAGE]: inconsistent_datapackage_1.rule,
    [registry.DATA_POINT_WITHOUT_INDICATOR]: datapoint_without_indicator_1.rule,
    [registry.DATA_POINT_UNEXPECTED_ENTITY_VALUE]: unexpected_entity_value_1.rule,
    [registry.DATA_POINT_UNEXPECTED_TIME_VALUE]: unexpected_time_value_1.rule,
    [registry.SAME_KEY_VALUE_CONCEPT]: same_key_value_concept_1.rule,
    [registry.DATAPACKAGE_NONEXISTENT_RESOURCE]: nonexistent_resource_1.rule,
    [registry.DATAPACKAGE_NONEXISTENT_CONCEPT]: nonexistent_concept_1.rule,
    [registry.WRONG_ENTITY_IS_HEADER]: wrong_entity_is_header_1.rule,
    [registry.WRONG_ENTITY_IS_VALUE]: wrong_entity_is_value_1.rule,
    [registry.NON_UNIQUE_ENTITY_VALUE]: non_unique_entity_value_1.rule,
    [registry.UNEXPECTED_DATA]: unexpected_data_1.rule,
    [registry.NON_DDF_DATA_SET]: non_ddf_dataset_1.rule,
    [registry.WRONG_DATA_POINT_HEADER]: wrong_data_point_header_1.rule,
    [registry.INCORRECT_IDENTIFIER]: incorrect_identifier_1.rule,
    [registry.INCORRECT_JSON_FIELD]: incorrect_json_field_1.rule,
    [registry.UNEXPECTED_TRANSLATION_HEADER]: unexpected_translation_header_1.rule,
    [registry.UNEXPECTED_TRANSLATIONS_DATA]: unexpected_translations_data_1.rule,
    [registry.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA]: unexpected_data_point_translations_data_1.rule,
    [registry.DUPLICATED_DATA_POINT_TRANSLATION_KEY]: duplicated_data_point_translation_key_1.rule,
    [registry.DUPLICATED_TRANSLATION_KEY]: duplicated_translation_key_1.rule,
    [registry.UNEXISTING_CONSTRAINT_VALUE]: unexisting_constraint_value_1.rule,
    [registry.INCORRECT_BOOLEAN_ENTITY]: incorrect_boolean_entity_1.rule,
    [registry.CONCEPT_LOOKS_LIKE_BOOLEAN]: concept_looks_like_boolean_1.rule,
    [registry.DATA_POINT_CONSTRAINT_VIOLATION]: constraint_violation_1.rule,
    [registry.DUPLICATED_DATA_POINT_KEY]: duplicated_data_point_key_1.rule,
    [registry.ENTITY_VALUE_AS_ENTITY_NAME]: entity_value_as_entity_name_1.rule,
    [registry.DUPLICATED_SYNONYM_KEY]: duplicated_synonym_key_1.rule,
    [registry.INCONSISTENT_SYNONYM_KEY]: inconsistent_synonym_key_1.rule
};
