"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UNEXPECTED_DATA = Symbol.for('UNEXPECTED_DATA');
exports.EMPTY_DATA = Symbol.for('EMPTY_DATA');
exports.NON_DDF_DATA_SET = Symbol.for('NON_DDF_DATA_SET');
exports.INCORRECT_FILE = Symbol.for('INCORRECT_FILE');
exports.INCORRECT_JSON_FIELD = Symbol.for('INCORRECT_JSON_FIELD');
exports.CONCEPT_ID_IS_NOT_UNIQUE = Symbol.for('CONCEPT_ID_IS_NOT_UNIQUE');
exports.INCORRECT_CONCEPT_TYPE = Symbol.for('INCORRECT_CONCEPT_TYPE');
exports.EMPTY_CONCEPT_ID = Symbol.for('EMPTY_CONCEPT_ID');
exports.EMPTY_ENTITY_ID = Symbol.for('EMPTY_ENTITY_ID');
exports.INCORRECT_IDENTIFIER = Symbol.for('INCORRECT_IDENTIFIER');
exports.NON_CONCEPT_HEADER = Symbol.for('NON_CONCEPT_HEADER');
exports.INVALID_DRILL_UP = Symbol.for('INVALID_DRILL_UP');
exports.MEASURE_VALUE_NOT_NUMERIC = Symbol.for('MEASURE_VALUE_NOT_NUMERIC');
exports.DATA_POINT_UNEXPECTED_ENTITY_VALUE = Symbol.for('DATA_POINT_UNEXPECTED_ENTITY_VALUE');
exports.DATA_POINT_UNEXPECTED_TIME_VALUE = Symbol.for('DATA_POINT_UNEXPECTED_TIME_VALUE');
exports.WRONG_DATA_POINT_HEADER = Symbol.for('WRONG_DATA_POINT_HEADER');
exports.SAME_KEY_VALUE_CONCEPT = Symbol.for('SAME_KEY_VALUE_CONCEPT');
exports.WRONG_ENTITY_IS_HEADER = Symbol.for('WRONG_ENTITY_IS_HEADER');
exports.WRONG_ENTITY_IS_VALUE = Symbol.for('WRONG_ENTITY_IS_VALUE');
exports.NON_UNIQUE_ENTITY_VALUE = Symbol.for('NON_UNIQUE_ENTITY_VALUE');
exports.CONCEPT_MANDATORY_FIELD_NOT_FOUND = Symbol.for('CONCEPT_MANDATORY_FIELD_NOT_FOUND');
exports.CONCEPTS_NOT_FOUND = Symbol.for('CONCEPTS_NOT_FOUND');
exports.DATAPACKAGE_INCORRECT_FIELDS = Symbol.for('DATAPACKAGE_INCORRECT_FIELDS');
exports.DATAPACKAGE_NON_CONCEPT_FIELD = Symbol.for('DATAPACKAGE_NON_CONCEPT_FIELD');
exports.DATAPACKAGE_INCORRECT_PRIMARY_KEY = Symbol.for('DATAPACKAGE_INCORRECT_PRIMARY_KEY');
exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME = Symbol.for('DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME');
exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE = Symbol.for('DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE');
exports.DATAPACKAGE_NONEXISTENT_RESOURCE = Symbol.for('DATAPACKAGE_NONEXISTENT_RESOURCE');
exports.DATAPACKAGE_NONEXISTENT_CONCEPT = Symbol.for('DATAPACKAGE_NONEXISTENT_CONCEPT');
exports.INCONSISTENT_DATAPACKAGE = Symbol.for('INCONSISTENT_DATAPACKAGE');
exports.UNEXPECTED_TRANSLATION_HEADER = Symbol.for('UNEXPECTED_TRANSLATION_HEADER');
exports.UNEXPECTED_TRANSLATIONS_DATA = Symbol.for('UNEXPECTED_TRANSLATIONS_DATA');
exports.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA = Symbol.for('UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA');
exports.DUPLICATED_DATA_POINT_TRANSLATION_KEY = Symbol.for('DUPLICATED_DATA_POINT_TRANSLATION_KEY');
exports.DUPLICATED_TRANSLATION_KEY = Symbol.for('DUPLICATED_TRANSLATION_KEY');
exports.DATA_POINT_WITHOUT_INDICATOR = Symbol.for('DATA_POINT_WITHOUT_INDICATOR');
exports.UNEXISTING_CONSTRAINT_VALUE = Symbol.for('UNEXISTING_CONSTRAINT_VALUE');
exports.DATA_POINT_CONSTRAINT_VIOLATION = Symbol.for('DATA_POINT_CONSTRAINT_VIOLATION');
exports.DUPLICATED_DATA_POINT_KEY = Symbol.for('DUPLICATED_DATA_POINT_KEY');
exports.INCORRECT_BOOLEAN_ENTITY = Symbol.for('INCORRECT_BOOLEAN_ENTITY');
exports.CONCEPT_LOOKS_LIKE_BOOLEAN = Symbol.for('CONCEPT_LOOKS_LIKE_BOOLEAN');
exports.ENTITY_VALUE_AS_ENTITY_NAME = Symbol.for('ENTITY_VALUE_AS_ENTITY_NAME');
exports.DUPLICATED_SYNONYM_KEY = Symbol.for('DUPLICATED_SYNONYM_KEY');
exports.INCONSISTENT_SYNONYM_KEY = Symbol.for('INCONSISTENT_SYNONYM_KEY');
exports.WARNING_TAG = Symbol.for('WARNING');
exports.FILE_SYSTEM_TAG = Symbol.for('FILE_SYSTEM');
exports.DATAPOINT_TAG = Symbol.for('DATAPOINT');
exports.TRANSLATION_TAG = Symbol.for('TRANSLATION');
exports.DATAPACKAGE_TAG = Symbol.for('DATAPACKAGE_TAG');
exports.WAFFLE_SERVER_TAG = Symbol.for('WAFFLE_SERVER_TAG');
function tagsToString(tags) {
    return tags.map(tag => Symbol.keyFor(tag));
}
exports.tags = {
    [exports.UNEXPECTED_DATA]: [exports.FILE_SYSTEM_TAG],
    [exports.EMPTY_DATA]: [exports.WARNING_TAG],
    [exports.NON_DDF_DATA_SET]: [exports.FILE_SYSTEM_TAG],
    [exports.INCORRECT_FILE]: [exports.FILE_SYSTEM_TAG, exports.DATAPACKAGE_TAG],
    [exports.INCORRECT_JSON_FIELD]: [exports.WARNING_TAG],
    [exports.CONCEPT_ID_IS_NOT_UNIQUE]: [],
    [exports.INCORRECT_CONCEPT_TYPE]: [],
    [exports.EMPTY_CONCEPT_ID]: [],
    [exports.EMPTY_ENTITY_ID]: [],
    [exports.INCORRECT_IDENTIFIER]: [],
    [exports.NON_CONCEPT_HEADER]: [],
    [exports.INVALID_DRILL_UP]: [],
    [exports.MEASURE_VALUE_NOT_NUMERIC]: [exports.WARNING_TAG, exports.DATAPOINT_TAG],
    [exports.DATA_POINT_UNEXPECTED_ENTITY_VALUE]: [exports.DATAPOINT_TAG],
    [exports.DATA_POINT_UNEXPECTED_TIME_VALUE]: [exports.DATAPOINT_TAG],
    [exports.WRONG_DATA_POINT_HEADER]: [exports.DATAPOINT_TAG],
    [exports.SAME_KEY_VALUE_CONCEPT]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_NONEXISTENT_RESOURCE]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_NONEXISTENT_CONCEPT]: [exports.DATAPACKAGE_TAG],
    [exports.INCONSISTENT_DATAPACKAGE]: [exports.DATAPACKAGE_TAG],
    [exports.WRONG_ENTITY_IS_HEADER]: [],
    [exports.WRONG_ENTITY_IS_VALUE]: [],
    [exports.NON_UNIQUE_ENTITY_VALUE]: [],
    [exports.CONCEPT_MANDATORY_FIELD_NOT_FOUND]: [],
    [exports.CONCEPTS_NOT_FOUND]: [],
    [exports.DATAPACKAGE_INCORRECT_FIELDS]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_NON_CONCEPT_FIELD]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_INCORRECT_PRIMARY_KEY]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME]: [exports.DATAPACKAGE_TAG],
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE]: [exports.DATAPACKAGE_TAG],
    [exports.UNEXPECTED_TRANSLATION_HEADER]: [exports.TRANSLATION_TAG],
    [exports.UNEXPECTED_TRANSLATIONS_DATA]: [exports.TRANSLATION_TAG],
    [exports.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA]: [exports.TRANSLATION_TAG, exports.DATAPOINT_TAG],
    [exports.DUPLICATED_DATA_POINT_TRANSLATION_KEY]: [exports.TRANSLATION_TAG, exports.DATAPOINT_TAG],
    [exports.DUPLICATED_TRANSLATION_KEY]: [exports.TRANSLATION_TAG],
    [exports.DATA_POINT_WITHOUT_INDICATOR]: [exports.DATAPOINT_TAG],
    [exports.UNEXISTING_CONSTRAINT_VALUE]: [],
    [exports.DATA_POINT_CONSTRAINT_VIOLATION]: [exports.DATAPOINT_TAG],
    [exports.DUPLICATED_DATA_POINT_KEY]: [exports.DATAPOINT_TAG],
    [exports.INCORRECT_BOOLEAN_ENTITY]: [],
    [exports.CONCEPT_LOOKS_LIKE_BOOLEAN]: [exports.WARNING_TAG],
    [exports.ENTITY_VALUE_AS_ENTITY_NAME]: [exports.WAFFLE_SERVER_TAG, exports.WARNING_TAG],
    [exports.DUPLICATED_SYNONYM_KEY]: [],
    [exports.INCONSISTENT_SYNONYM_KEY]: []
};
exports.descriptions = {
    [exports.UNEXPECTED_DATA]: 'Invalid CSV file is found. Number of columns in header does not match that of each row.',
    [exports.EMPTY_DATA]: 'Empty data found in CSV. Filename and header are good, but no further data follows.',
    [exports.NON_DDF_DATA_SET]: 'The folder content is not recognized as a DDFCSV dataset.',
    [exports.INCORRECT_FILE]: 'Error reading a file.',
    [exports.INCORRECT_JSON_FIELD]: 'Incorrect JSON field.',
    [exports.CONCEPT_ID_IS_NOT_UNIQUE]: 'Concept Id is not unique.',
    [exports.INCORRECT_CONCEPT_TYPE]: 'Concept type does not correspond to any of the available DDF concept types.',
    [exports.EMPTY_CONCEPT_ID]: 'Empty concept ID is found.',
    [exports.EMPTY_ENTITY_ID]: 'Empty entity ID is found.',
    [exports.INCORRECT_IDENTIFIER]: 'Incorrect identifier is found.',
    [exports.NON_CONCEPT_HEADER]: 'Found a value in header that is not among the concepts.',
    [exports.INVALID_DRILL_UP]: 'Invalid Drill Up property value is found.',
    [exports.MEASURE_VALUE_NOT_NUMERIC]: 'Measure has non-numeric value(s).',
    [exports.DATA_POINT_UNEXPECTED_ENTITY_VALUE]: 'Datapoint refers to a missing or a misspelled entity.',
    [exports.DATA_POINT_UNEXPECTED_TIME_VALUE]: 'Datapoint has an incorrect time value.',
    [exports.WRONG_DATA_POINT_HEADER]: 'Invalid datapoint file header. One of the keys has an incorrect concept_type or key from datapackage does not correspond with header of the file.',
    [exports.SAME_KEY_VALUE_CONCEPT]: 'Datapackage: Key-value pair is found in datapackage.json where the key contains the same concept(s) as does the value.',
    [exports.WRONG_ENTITY_IS_HEADER]: 'Incorrect "is" entity property header. It may only reference a concept of type "entity_set".',
    [exports.WRONG_ENTITY_IS_VALUE]: 'Incorrect value found in the column with "is" header. Only boolean values are allowed.',
    [exports.NON_UNIQUE_ENTITY_VALUE]: 'A non-unique entity value was found within an entity domain.',
    [exports.CONCEPT_MANDATORY_FIELD_NOT_FOUND]: 'A concept is missing a mandatory property. Mandatory fields are not the same for all concept types.',
    [exports.CONCEPTS_NOT_FOUND]: 'Concepts are not found.',
    [exports.DATAPACKAGE_INCORRECT_FIELDS]: 'Datapackage: Incorrect fields found in datapackage.json.',
    [exports.DATAPACKAGE_NON_CONCEPT_FIELD]: 'Datapackage: Non-concept primary key found in datapackage.json.',
    [exports.DATAPACKAGE_INCORRECT_PRIMARY_KEY]: 'Datapackage: Fields section does not contain primary key.',
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME]: 'Datapackage: Non-unique resource name found in datapackage.json.',
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE]: 'Datapackage: Non-unique resource file found in datapackage.json.',
    [exports.DATAPACKAGE_NONEXISTENT_RESOURCE]: 'Resource found in datapackage that is not present in folder',
    [exports.DATAPACKAGE_NONEXISTENT_CONCEPT]: 'Concept found in datapackage but is not listed in concepts table',
    [exports.INCONSISTENT_DATAPACKAGE]: 'datapackage.json does not meet "Data Package" requirements (https://frictionlessdata.io/specs/data-package/) or some mandatory sections are missing',
    [exports.UNEXPECTED_TRANSLATION_HEADER]: 'Translations: Unexpected header in translation files',
    [exports.UNEXPECTED_TRANSLATIONS_DATA]: 'Translations: Unexpected translations data: primary key is not consistent.',
    [exports.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA]: 'Translations: Unexpected translations datapoint data: primary key is not consistent.',
    [exports.DUPLICATED_DATA_POINT_TRANSLATION_KEY]: 'Translations: Duplicated data point translation key.',
    [exports.DUPLICATED_TRANSLATION_KEY]: 'Translations: Duplicated translation key.',
    [exports.DATA_POINT_WITHOUT_INDICATOR]: 'Datapackage: Found a datapoint file description without an indicator: primary key array is equal to fields array.',
    [exports.UNEXISTING_CONSTRAINT_VALUE]: 'Datapackage: Constraint value listed in datapackage.json is not a valid entity value.',
    [exports.DATA_POINT_CONSTRAINT_VIOLATION]: 'Constraint violation for particular datapoint.',
    [exports.DUPLICATED_DATA_POINT_KEY]: 'Duplicated key is found in datapoint file.',
    [exports.INCORRECT_BOOLEAN_ENTITY]: 'Boolean entitiy field has an incorrect value.',
    [exports.CONCEPT_LOOKS_LIKE_BOOLEAN]: 'Entity contains values that look like boolean, but related entity field has a different type.',
    [exports.ENTITY_VALUE_AS_ENTITY_NAME]: 'Entity value should not be equal to entity domain name or entity set name. This rule providing is critical for DDFQL and DDF reader supporting (on WS).',
    [exports.DUPLICATED_SYNONYM_KEY]: 'Duplicated synonym key',
    [exports.INCONSISTENT_SYNONYM_KEY]: 'Inconsistent Synonym key'
};
exports.howToFix = {
    [exports.UNEXPECTED_DATA]: 'The additional info should tell which CSV file is corrupted. Use csvlint.io to find the issues inside the CSV files.',
    [exports.EMPTY_DATA]: 'All CSV files in the dataset should have at least one row beyond the header or need to be removed',
    [exports.NON_DDF_DATA_SET]: 'Pick the folder that contains the DDF dataset. More info can be found under DDFcsv format description here: https://open-numbers.github.io/ddf.html',
    [exports.INCORRECT_FILE]: 'Check that files do not contain unprintable characters (spaces, tabs etc) or exists. The safe bet is when your filenames only contain english alphanumeric characters, underscores, hyphens and a dot before extension',
    [exports.INCORRECT_JSON_FIELD]: 'A value is suspected to be a JSON but can not be successfully parsed as such. For example, "Congo [DRC]" should rather look like "Congo, DRC"',
    [exports.CONCEPT_ID_IS_NOT_UNIQUE]: 'Check ddf--concepts.csv file. The values in column "concept" should never repeat.',
    [exports.INCORRECT_CONCEPT_TYPE]: 'In column "concept_type" only the following options are allowed: boolean, string, measure, entity_domain, entity_set, time, year, week, month, day, quarter, interval, role, custom_type. See the docs about DDF conceptual model for more info https://open-numbers.github.io/ddf.html',
    [exports.EMPTY_CONCEPT_ID]: 'Check ddf--concepts.csv file. Concept ID should never be empty.',
    [exports.EMPTY_ENTITY_ID]: 'Check ddf--entities-xxx.csv file. Entity ID should never be empty.',
    [exports.INCORRECT_IDENTIFIER]: 'Entity and concept identifiers can only contain lowercase alphanumeric english characters and underscores.',
    [exports.NON_CONCEPT_HEADER]: 'Each part of any header should be a concept in ddf--concepts.csv file ("is--" field is an exception).',
    [exports.INVALID_DRILL_UP]: 'Check ddf--concepts.csv file, column "drill_up". The value should be an array of existing concepts like "[""concept1"",""concept2""]"',
    [exports.MEASURE_VALUE_NOT_NUMERIC]: 'Check that every column of concept_type measure contains only numeric values.',
    [exports.DATA_POINT_UNEXPECTED_ENTITY_VALUE]: 'Check that the entity ID listed in details is present in the entity file and is spelled correctly.',
    [exports.DATA_POINT_UNEXPECTED_TIME_VALUE]: 'Check that time values are consistently following one of these patterns: 2017, 2017q1, 2017w03, 20170328, 201703. For more info see DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.WRONG_DATA_POINT_HEADER]: 'Only concepts of types "time", "entity_domain" and "entity_set" are allowed to be used as keys in datapoints files. The header should be correctly reflected in datapackage.json (see how you can rebuild datapackage here: https://github.com/Gapminder/ddf-validation#datapackage)',
    [exports.SAME_KEY_VALUE_CONCEPT]: 'If a concept is already included in key it should not appear as value in schemas of datapackage.json. You can fix it manually or regenerate datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.WRONG_ENTITY_IS_HEADER]: 'Edit the header to reference one of the entity sets. For example a correct header can be "is--country", where "country" is a concept of type "entity_set". More info in DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.WRONG_ENTITY_IS_VALUE]: 'Replace values in "is"-column with booleans. Safe to use them in capitals, like TRUE and FALSE. More info in DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.NON_UNIQUE_ENTITY_VALUE]: 'Entity IDs in one entity domain and all sets in that domain should be unique. Like you can not have two country IDs "korea". But you can have country ID "male" and gender ID "male" since they are in different entity domains. More info in DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.CONCEPT_MANDATORY_FIELD_NOT_FOUND]: 'Check ddf--concepts.csv file. For all concepts "concept_type" should be defined. For entity sets "domain" is mandatory and should reference an "entity_domain". For roles "domain" is mandatory and should reference an "entity_set" or an "entity_domain". More info in DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.CONCEPTS_NOT_FOUND]: 'Check ddf--concepts.csv file. It should exist and contain a list with values defined ar least in columns "concept" and "concept_type". More info in DDF conceptual model: https://open-numbers.github.io/ddf.html',
    [exports.DATAPACKAGE_INCORRECT_FIELDS]: 'Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.DATAPACKAGE_NON_CONCEPT_FIELD]: 'Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.DATAPACKAGE_INCORRECT_PRIMARY_KEY]: 'Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_NAME]: 'Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.DATAPACKAGE_NON_UNIQUE_RESOURCE_FILE]: 'Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.DATAPACKAGE_NONEXISTENT_RESOURCE]: 'Resource found in datapackage that is not present in folder',
    [exports.DATAPACKAGE_NONEXISTENT_CONCEPT]: 'Concept found in datapackage but is not listed in concepts table',
    [exports.INCONSISTENT_DATAPACKAGE]: 'Fix datapackage.json format in accordance with "Data Package" requirements (https://frictionlessdata.io/specs/data-package/) or add mandatory sections (ddfSchema).',
    [exports.UNEXPECTED_TRANSLATION_HEADER]: 'Remove the resource from datapackage or restore it in the folder',
    [exports.UNEXPECTED_TRANSLATIONS_DATA]: 'Remove the resource from datapackage or add it to the concepts table',
    [exports.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA]: '',
    [exports.DUPLICATED_DATA_POINT_TRANSLATION_KEY]: '',
    [exports.DUPLICATED_TRANSLATION_KEY]: '',
    [exports.DATA_POINT_WITHOUT_INDICATOR]: 'Datapoint files without indicator make no sense and you should remove them. Then regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage',
    [exports.UNEXISTING_CONSTRAINT_VALUE]: 'If entity IDs are enumerated in datapoint filenames, check that they are present in the respective entity tables. Enumerated entity constraints in datapackage.json should then match. Regenerate or update datapackage as described here: https://github.com/Gapminder/ddf-validation#datapackage. More info on DDFcsv file naming: https://open-numbers.github.io/ddf.html',
    [exports.DATA_POINT_CONSTRAINT_VIOLATION]: 'Some datapoints do not conform the entity constraints imposed in their filenames and/or in datapackage.json. More info on DDFcsv file naming: https://open-numbers.github.io/ddf.html',
    [exports.DUPLICATED_DATA_POINT_KEY]: 'Datapoint files should have unique keys',
    [exports.INCORRECT_BOOLEAN_ENTITY]: 'Use only TRUE or FALSE values for concepts of type "boolean"',
    [exports.CONCEPT_LOOKS_LIKE_BOOLEAN]: 'Consider changing the concept type to "boolean"',
    [exports.ENTITY_VALUE_AS_ENTITY_NAME]: 'Simplest way to fix the issue is entity value renaming, in other case domain or entity set name should be changed.',
    [exports.DUPLICATED_SYNONYM_KEY]: 'Remove duplicated key or change it properly',
    [exports.INCONSISTENT_SYNONYM_KEY]: 'Correct key as (entity and synonym should be defined) in a related ddf--synonyms--xxx.csv file'
};
exports.getRulesInformation = () => Object.getOwnPropertySymbols(exports.descriptions)
    .reduce((result, issueType) => `${result}${Symbol.keyFor(issueType)} -> ${exports.descriptions[issueType]}
      tags: ${tagsToString(exports.tags[issueType])}\n\n`, 'Supported rules are:\n\n');
