"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const constants_1 = require("../../ddf-definitions/constants");
const issue_1 = require("../issue");
exports.rule = {
    isTranslation: true,
    rule: (ddfDataSet) => lodash_1.compact(lodash_1.flattenDeep(ddfDataSet.fileDescriptors.map(fileDescriptor => {
        return fileDescriptor.getExistingTranslationDescriptors()
            .filter(translationDescriptor => translationDescriptor.type !== constants_1.DATA_POINT)
            .map(translationDescriptor => {
            const primaryKeys = translationDescriptor.content.map(record => record[translationDescriptor.primaryKey.toString()]);
            const duplications = lodash_1.filter(primaryKeys, (value, index, iteratee) => lodash_1.includes(iteratee, value, index + 1));
            let issue = null;
            if (!lodash_1.isEmpty(duplications)) {
                issue = new issue_1.Issue(registry_1.DUPLICATED_TRANSLATION_KEY)
                    .setPath(translationDescriptor.fullPath)
                    .setData(duplications);
            }
            return issue;
        });
    })))
};
