"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    isTranslation: true,
    recordRule: dataPointDescriptor => {
        const emptyDataUnderPrimaryKey = dataPointDescriptor.fileDescriptor.primaryKey.filter(primaryKeyPart => !dataPointDescriptor.record[primaryKeyPart]);
        if (!lodash_1.isEmpty(emptyDataUnderPrimaryKey)) {
            return new issue_1.Issue(registry_1.UNEXPECTED_DATA_POINT_TRANSLATIONS_DATA)
                .setPath(dataPointDescriptor.fileDescriptor.fullPath)
                .setData({
                record: dataPointDescriptor.record,
                primaryKey: dataPointDescriptor.fileDescriptor.primaryKey
            });
        }
        return null;
    }
};
