"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const registry_1 = require("../registry");
const issue_1 = require("../issue");
exports.rule = {
    isTranslation: true,
    rule: (ddfDataSet) => {
        const getDataConsistencyIssues = (primaryKey, transFileDescriptor) => transFileDescriptor.content
            .filter(transRecord => !transRecord[primaryKey])
            .map(transRecord => ({ transRecord, primaryKey, transFileDescriptor }));
        const fileDescriptorsToCheck = lodash_1.concat(ddfDataSet.getConcept().fileDescriptors, ddfDataSet.getEntity().fileDescriptors);
        const dataConsistencyIssuesSources = lodash_1.compact(lodash_1.flattenDeep(fileDescriptorsToCheck.map(fileDescriptor => fileDescriptor.transFileDescriptors
            .filter(transFileDescriptor => lodash_1.isEmpty(transFileDescriptor.issues))
            .map(transFileDescriptor => getDataConsistencyIssues(fileDescriptor.primaryKey, transFileDescriptor))
            .filter(issueSource => !!issueSource))));
        return dataConsistencyIssuesSources.map(issueSource => new issue_1.Issue(registry_1.UNEXPECTED_TRANSLATIONS_DATA)
            .setPath(issueSource.transFileDescriptor.fullPath)
            .setData({
            record: issueSource.transRecord,
            primaryKey: issueSource.primaryKey
        }));
    }
};
