/// <reference types="node" />
import { EventEmitter } from 'events';
import { FileDescriptor } from '../data/file-descriptor';
import { DdfDataSet } from '../ddf-definitions/ddf-data-set';
import { IssuesFilter } from '../utils/issues-filter';
export declare const isRecordRule: (ruleObject: any) => boolean;
export declare const isAggregativeRule: (ruleObject: any) => boolean;
export declare class ProcessOneDataPointsChunkStory {
    private fileDescriptors;
    private issueEmitter;
    private sent;
    private rulesWrappers;
    private customRules;
    constructor(fileDescriptors: FileDescriptor[], issueEmitter: EventEmitter);
    withCustomRules(customRules?: any[]): ProcessOneDataPointsChunkStory;
    collect(ddfDataSet: DdfDataSet, issuesFilter: IssuesFilter, onDataCollected: any): void;
    analyze(): void;
    getTotal(): number;
    private getRuleWrappers(issuesFilter);
}
