"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
exports.isDdfTrue = value => value === 'TRUE' || value === 'true';
exports.isDdfFalse = value => value === 'FALSE' || value === 'false';
exports.isDdfBoolean = value => exports.isDdfTrue(value) || exports.isDdfFalse(value);
exports.fieldIsPrefix = 'is--';
exports.looksLikeIsField = field => lodash_1.startsWith(field, exports.fieldIsPrefix);
exports.CONCEPT_TYPE_BOOLEAN = 'boolean';
exports.CONCEPT_TYPE_STRING = 'string';
exports.CONCEPT_TYPE_MEASURE = 'measure';
exports.CONCEPT_TYPE_ENTITY_DOMAIN = 'entity_domain';
exports.CONCEPT_TYPE_ENTITY_SET = 'entity_set';
exports.CONCEPT_TYPE_TIME = 'time';
exports.CONCEPT_TYPE_YEAR = 'year';
exports.CONCEPT_TYPE_WEEK = 'week';
exports.CONCEPT_TYPE_MONTH = 'month';
exports.CONCEPT_TYPE_DAY = 'day';
exports.CONCEPT_TYPE_QUARTER = 'quarter';
exports.CONCEPT_TYPE_INTERVAL = 'interval';
exports.CONCEPT_TYPE_ROLE = 'role';
exports.CONCEPT_TYPE_CUSTOM_TYPE = 'custom_type';
exports.CONCEPT_TYPES = [
    exports.CONCEPT_TYPE_BOOLEAN,
    exports.CONCEPT_TYPE_STRING,
    exports.CONCEPT_TYPE_MEASURE,
    exports.CONCEPT_TYPE_ENTITY_DOMAIN,
    exports.CONCEPT_TYPE_ENTITY_SET,
    exports.CONCEPT_TYPE_TIME,
    exports.CONCEPT_TYPE_YEAR,
    exports.CONCEPT_TYPE_WEEK,
    exports.CONCEPT_TYPE_MONTH,
    exports.CONCEPT_TYPE_DAY,
    exports.CONCEPT_TYPE_QUARTER,
    exports.CONCEPT_TYPE_INTERVAL,
    exports.CONCEPT_TYPE_ROLE,
    exports.CONCEPT_TYPE_CUSTOM_TYPE
];
