"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const lodash_1 = require("lodash");
const semver_1 = require("semver");
const chalk_1 = require("chalk");
exports.checkLatestVersion = (currentVersion, appExitCode) => {
    child_process_1.exec('npm show ddf-validation version', (err, _latestVersion) => {
        const latestVersion = (_latestVersion || '').trim();
        if (!err && !lodash_1.isEmpty(latestVersion)) {
            if (semver_1.valid(latestVersion) && semver_1.lt(currentVersion, latestVersion)) {
                console.log(`Current version ${chalk_1.red(currentVersion)} is too old. New version is ${chalk_1.green(latestVersion)}. To update run "npm i -g ddf-validation"`);
            }
        }
        if (appExitCode || appExitCode === 0) {
            process.exit(appExitCode);
        }
    });
};
